
function reset_anima8()
  for i = 1, #body.direction do
    sprite.animation[body.direction[i]]:gotoFrame(1)
  end
  for i = 1, #body.type do
    body.turn[body.type[i]]:gotoFrame(1)
  end
end

function pause_anim8()
  for i = 1, #body.direction do
    sprite.animation[body.direction[i]]:pause()
  end
  for i = 1, #body.type do
    body.turn[body.type[i]]:pause()
  end
end

function resume_anim8()
  for i = 1, #body.direction do
    sprite.animation[body.direction[i]]:resume()
  end
  for i = 1, #body.type do
    body.turn[body.type[i]]:resume()
  end
end


function love.keypressed(key, scancode, isrepeat)
  if key == 'end' then
    love.event.quit()
  end
  if key == 'tab' then --export canvas
    sprite.imageData = sprite.canvas:newImageData( )
    sprite.fileData = sprite.imageData:encode( "png", "char.png" )
    face.imageData = face.canvas:newImageData( )
    face.fileData = face.imageData:encode( "png", "face.png" )
  end
  if key == "p" and global_anim8.state == "play" then
    pause_anim8()
    global_anim8.state = "pause"
  elseif key == "p" and global_anim8.state == "pause" then
    resume_anim8()
    global_anim8.state = "play"
  end
  if key == "o" then
    reset_anima8()
  end
end

function button_hover(checkX,checkY,buttonX,buttonY,buttonW,buttonH)
  if (checkX > buttonX) and (checkX < buttonX + buttonW) and
  (checkY > buttonY) and (checkY < buttonY + buttonH) then
    return true
  else
    return false
  end
end

function love.mousepressed(x, y, button, isTouch)
  if button == 1 then
    --input
    input_labels()
    input_sprites()
    input_body()
  elseif button == 2 then
    --reset
    reset_labels()
  end
end

function input_sprites()
  local dx,dy = anim8sprite_x, anim8sprite_y
  local _x = x or dx
  local _y = y or dy
  if labels.select == "" then
    for i = 0, 3 do
      local x, y, w, h = _x, _y + i*128, 64, 128
      local check = button_hover(mouse.x,mouse.y,x,y,w,h)
      local index = i + 1
      if check then
        sprite.select = body.direction[index]
      end
    end
  end
end

function input_body()
  local dx,dy = anim8sprite_x, anim8sprite_y
  local _x = x or dx
  local _y = y or dy
  if labels.select == "Body" then
    for i = 0, 3 do
      local x, y, w, h = _x, _y + i*128, 64, 128
      local check = button_hover(mouse.x,mouse.y,x,y,w,h)
      local index = i + 1
      if check then
        body.select = body.type[index]
      end
    end
  end
end

function input_labels()
  local dx,dy = labels_x, labels_y
  local _x = dx
  local _y = dy
  local div_y = labels_divY
  for i = 0, (#labels - 1) do
    labels.state[i+1] = button_hover(mouse.x, mouse.y, _x, _y + (i*(u/div_y)), labels.w, labels.h)
  end
  --update selection of labels
  for i = 1, #labels do
    if labels.state[i] then
      labels.select = labels[i]
    end
  end
end

function reset_labels()
  --cancel selection
  labels.select = ""
  --reset state
  for i = 0, 9 do
    labels.state[i+1] = false
  end
end
