--require libs
anim8 = require "lib/anim8-master/anim8" --Animation Library

--Canvas Blend Modes and Alpha Modes
  --alpha, replace, screen, add, subtract, multiply, lighten, darken
BlendMode = {
  "alpha", --1
  "replace", --2
  "screen", --3
  "add", --4
  "subtract", --5
  "multiply", --6
  "lighten", --7
  "darken" --8
}
AlphaMode = {"alphamultiply","premultiplied"}

function setCanvas(canvas,imageTable,imageLayers)
  love.graphics.setCanvas(canvas)
      love.graphics.clear()
      for i = 1, #imageLayers do
        if imageLayers[i] == "skin" then
          love.graphics.setBlendMode("multiply","premultiplied") --default is 1,1
        else
          love.graphics.setBlendMode("alpha") --default is 1,1
        end
        love.graphics.setColor(1, 1, 1, 1)
        love.graphics.draw(imageTable[imageLayers[i]], 0, 0)
      end
  love.graphics.setCanvas()
end

global_anim8 = {} --global animation defualt properties
global_anim8.state = "play"
global_anim8.speed = 0.5
--load
file = {}
file.directory = "DeGen" --Save Directory Name
love.filesystem.setIdentity(file.directory)

window = {w = love.graphics.getWidth(), h = love.graphics.getHeight()}
love.graphics.setDefaultFilter('nearest','nearest',1) --Pixel Perfect No Blurring

font = {
  love.graphics.newFont("font/Pixel UniCode.ttf", fontSize), --Game Font
  love.graphics.newFont("font/Pixel UniCode.ttf", console_fontSize), --Log Font
}
love.graphics.setFont(font[1])

mouse = { --mouse psotion Vector2
  x = 0,
  y = 0
}

labels = {
  "Body", --Layer 1
  "Hair", --Layer 2
  "Brows", --Layer 3
  "Eyes", --Layer 4
  "Nose", --Layer 5
  "Mouth", --Layer 6
  "Outfit", --Layer 7
  "Color",
  "Random",
  "Export",
  "Import",
  "Save",
  "Load"
}
labels.mode = "line"
labels.w, labels.h = u*2.25, u/2.5
labels.state = {} --boolean state for button pressed
for i = 1, #labels do
  labels.state[i] = false
end
labels.select = "" --string state for what was slected

body = {} --body template type and turn around graphics
body.type = { --various types of bodies
  "adultFemale", --character index 1
  "adultMale", --character index 2
  "teenFemale", --character index 3
  "teenMale" --character index 4
}
body.direction = { --animation directions 4 way movement
  "front",
  "left",
  "right",
  "back"
}
body.w = 64 --body single frame bounding box width dimenison
body.h = 128 --body single frame bounding box height dimension
body.atlas = love.graphics.newImage("img/preview/selection_body.png") --atlas of all 4 body types
local g = anim8.newGrid(body.w, body.h, body.atlas:getWidth(), body.atlas:getHeight())
local animspeed = global_anim8.speed
body.turn = {} --body turn arounds
for i = 1, #body.type do --cycle all character indexes 1 to 4
  body.turn[body.type[i]] = anim8.newAnimation(g('1-4',i), animspeed) --turn around animation per body type
end
body.select = body.type[1] --1 is "adult-female"

face = {} --face graphic
face.layers = {
  "body", --Layer 1
  "skin",
  "hair", --Layer 2
  "brows", --Layer 3
  "eyes", --Layer 4
  "nose", --Layer 5
  "mouth", --Layer 6
  "outfit", --Layer 7
}
face.w = 72 --face original size width dimeions
face.h = 72 --face original size height dimension
face.canvas = love.graphics.newCanvas(face.w, face.h)
face.img = {} --2D Array table. File Directories Used in ArrayImage
--setup layered images
for i = 1, #body.type do --loop body types
  face.img[body.type[i]] = {}
  for j = 1, #face.layers do --loop body layers
  face.img[body.type[i]][face.layers[j]] = love.graphics.newImage(
  "img/faces/"..body.type[i].."/"..face.layers[j]..".png"
  )
  end
end
setCanvas(face.canvas,face.img[body.type[1]],face.layers)

sprite = {} --sprite images
sprite.layers = {
  "body",
  "skin",
  "hair",
  "brows",
  "eyes",
  "nose",
  "mouth",
  "outfit",
}
sprite.w = 64 --sprite single grid width
sprite.h = 128 --sprite single grid height
sprite.canvas = love.graphics.newCanvas(sprite.w*4, sprite.h*4)
sprite.img = {} --2D Array table. File Directories Used in ArrayImage
--setup layered images
for i = 1, #body.type do --loop body types
  sprite.img[body.type[i]] = {}
  for j = 1, #sprite.layers do --loop body layers
  sprite.img[body.type[i]][sprite.layers[j]] = love.graphics.newImage(
  "img/sprites/"..body.type[i].."/"..sprite.layers[j]..".png"
  )
  end
end
--setup animation grids
local g = anim8.newGrid(sprite.w, sprite.h, sprite.w*4, sprite.h*4) --4 by 4 sprite sheet
local animspeed = global_anim8.speed
sprite.animation = {}
  for i = 1, #body.direction do --loop all directions of animation
  sprite.animation[body.direction[i]] = anim8.newAnimation(g('1-4',i), animspeed)
  end
sprite.select = body.direction[1] --defualt is "front" direction selected for preview
setCanvas(sprite.canvas,sprite.img[body.type[1]],sprite.layers)
